﻿@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<script type="text/javascript" src="http://maps.googleapis.com/maps/api/js?sensor=false&key=AIzaSyBfPWT55ybzPawdPYh58Y85LICkYHQe27U&libraries=places&callback=initMap" async defer></script>
<div class="row">
    <h3>Data Rumah</h3>
    <div class="col-md-6">

    </div>
    <div class="col-md-6 pull-right">
        <div class="pull-right">
            <a class="btn btn-info" href="@Url.Action("Add","DataRumah")">
                <i class="glyphicon glyphicon-plus"></i> Add
            </a>
        </div>
    </div>
</div>
<div class="row" style="margin-top:5px">
    <div class="col-md-5">
        <table id="tblIndex" class="table table-bordered">
            <thead>
                <tr>
                    <td>Action</td>
                    <td>Alamat</td>
                    <td>Type</td>
                    <td>Latitude</td>
                    <td>Longitude</td>
                </tr>
            </thead>
            <tbody>
                @{
                    foreach (TestRadyaLab.Models.Rumah item in (List<TestRadyaLab.Models.Rumah>)ViewBag.listData)
                    {
                <tr>
                    <td>
                        <a href="@Url.Action("Edit", "DataRumah", new { id = item.Id })" class="glyphicon glyphicon-edit"></a>
                        <a href="@Url.Action("Delete", "DataRumah", new { id = item.Id })" class="glyphicon glyphicon-remove"></a>
                    </td>
                    <td>
                        @item.Alamat
                    </td>
                    <td>
                        @item.Tipe
                    </td>
                    <td>
                        @item.Lat
                    </td>
                    <td>
                        @item.Long
                    </td>
                </tr>
                    }
                }
            </tbody>
        </table>
    </div>
    <div class="col-md-7">
        <div id="map" style="width: 100%; height: 500px;"></div>
    </div>
</div>

<div id="ModalMap" class="modal fade" role="dialog">
    <div class="modal-dialog modal-lg">
        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">

            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>
@section scripts{
    <script type="text/javascript">
        var dataProvinsi = [];
        var dataKota = [];
        var dataKecamatan = [];
        var dataLokasi = [];
        var geocoder;
        var map;
        var markers = [];
        @foreach (TestRadyaLab.Models.Rumah item in (List<TestRadyaLab.Models.Rumah>)ViewBag.listData)
        {
            if (item.Provinsi != null && item.Provinsi != "")
            {
                                <text>
        if (jQuery.inArray('@item.Provinsi', dataProvinsi))
            dataProvinsi.push('@item.Provinsi')
        </text>
            }
            if (item.Kota != null && item.Kota != "")
            {
                                <text>
        if (jQuery.inArray('@item.Kota', dataKota))
            dataKota.push('@item.Kota')
        </text>
            }
            if (item.Kecamtan != null && item.Kecamtan != "")
            {
                                <text>
        if (jQuery.inArray('@item.Kecamtan', dataKecamatan))
            dataKecamatan.push('@item.Kecamtan')
        </text>
            }

            <text>
        dataLokasi.push('@item.Alamat')
        </text>
        }

        function initMap() {
            geocoder = new google.maps.Geocoder();
            map = new google.maps.Map(document.getElementById('map'), {
                zoom: 4,
                center: new google.maps.LatLng(-6.9170227, 107.63337000000001),
            });

            var infowindow = new google.maps.InfoWindow();

            map.addListener('zoom_changed', function () {
                for (var i = 0; i < markers.length; i++) {
                    markers[i].setMap(null);
                }
                markers = [];
                if (map.getZoom() >= 14) {
                    $.each(dataLokasi, function (index, value) {
                        geocoder.geocode({ 'address': value }, function (results, status) {
                            if (status == google.maps.GeocoderStatus.OK) {
                                var marker = new google.maps.Marker(
                                {
                                    map: map,
                                    draggable: false,
                                    position: results[0].geometry.location,
                                    title: value
                                });
                                marker.setVisible(true);
                                markers.push(marker);
                            } else {
                                alert('Geocode was not successful for the following reason: ' + status);
                            }
                        });
                    })
                }
                else if (map.getZoom() >= 10 && map.getZoom() < 14) {
                    $.each(dataKota, function (index, value) {
                        geocoder.geocode({ 'address': value }, function (results, status) {
                            if (status == google.maps.GeocoderStatus.OK) {
                                var marker = new google.maps.Marker(
                                {
                                    map: map,
                                    draggable: false,
                                    position: results[0].geometry.location,
                                    title: value
                                });
                                marker.setVisible(true);
                                markers.push(marker);
                            } else {
                                alert('Geocode was not successful for the following reason: ' + status);
                            }
                        });
                    })
                }
                else if (map.getZoom() > 0 && map.getZoom() < 10) {
                    $.each(dataProvinsi, function (index, value) {
                        geocoder.geocode({ 'address': value }, function (results, status) {
                            if (status == google.maps.GeocoderStatus.OK) {
                                var marker = new google.maps.Marker(
                                {
                                    map: map,
                                    draggable: false,
                                    position: results[0].geometry.location,
                                    title: value
                                });
                                marker.setVisible(true);
                                markers.push(marker);
                            } else {
                                alert('Geocode was not successful for the following reason: ' + status);
                            }
                        });
                    })
                }

                
            });
        }

        $(document).ready(function () {
            $('#tblIndex').DataTable({});
        })
    </script>
}
